package com.tianyi.sync.task;

import com.tianyi.sync.service.DataSyncService;
import com.tianyi.sync.service.LiabilitiesDataSyncService;
import com.tianyi.sync.service.ProfitDataSyncService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.*;


@EnableAsync
@Configuration
@EnableScheduling
public class ScheduleTask {

    private final static Logger logger = LoggerFactory.getLogger(ScheduleTask.class);

    private final DataSyncService dataSyncService;

    private final ProfitDataSyncService profitDataSyncService;
    private final LiabilitiesDataSyncService liabilitiesDataSyncService;

    public ScheduleTask(DataSyncService dataSyncService, ProfitDataSyncService profitDataSyncService, LiabilitiesDataSyncService liabilitiesDataSyncService) {
        this.dataSyncService = dataSyncService;
        this.profitDataSyncService = profitDataSyncService;
        this.liabilitiesDataSyncService = liabilitiesDataSyncService;
    }

    /**
     * 每月5号零点执行一次
     */
    @Async
    @Scheduled(cron = "0 0 0 5 * ?")
    public void scheduleTask() {
        dataSyncService.sync();
        logger.info("定时任务执行成功!!!!!!");
    }
    /**
     * 每月5号零点执行一次
     */
    @Async
    @Scheduled(cron = "0 0 0 5 * ?")
    public void profitTask() {
        profitDataSyncService.profitSync();
        logger.info("定时任务执行成功!!!!!!");
    }
    /**
     * 每月5号零点15分执行一次
     */
    @Async
    @Scheduled(cron = "0 15 0 5 * ?")
    public void liabilitiesTask() {
        liabilitiesDataSyncService.liabilitiesSync();
        logger.info("资产负债定时任务执行成功!!!!!!");
    }
}
